pms/urls.py
from django.contrib import admin
from django.urls import path
from django.contrib import admin
from django.conf import settings as SETTINGS
from django.conf.urls.static import static
from django.urls import include, re_path
from core import views as core_views



urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^app/accounts/', include('registration.backends.default.urls')),

    re_path(r'^$', core_views.App.as_view(), name='app'),
    re_path(r'^app/$', core_views.App.as_view(), name='app'),
    re_path(r'^app/dashboard/$', core_views.DashboardView.as_view(), name='dashboard'),

    re_path(r'^app/properties/', include('properties.urls')),
    re_path(r'^app/tenants/', include('tenants.urls')),





] + static(SETTINGS.STATIC_URL, document_root=SETTINGS.STATIC_ROOT) + static(SETTINGS.MEDIA_URL, document_root=SETTINGS.MEDIA_ROOT)

handler404 = 'core.views.page_not_found'
handler500 = 'core.views.error'
handler403 = 'core.views.permission_denied'
handler400 = 'core.views.bad_request'

properties/urls.py
from django.urls import re_path
from properties import views

app_name = 'properties'

urlpatterns = [
    # Feature year URLs
    re_path(r'^features/create/$', views.FeatureCreateView.as_view(), name='feature_create'),
    re_path(r'^features/view/(?P<pk>[0-9a-f-]+)/$', views.FeatureDetailView.as_view(), name='feature_view'),
    re_path(r'^features/list/$', views.FeatureListView.as_view(), name='feature_list'),
    re_path(r'^features/update/(?P<pk>[0-9a-f-]+)/$', views.FeatureUpdateView.as_view(), name='feature_update'),
    re_path(r'^features/delete/(?P<pk>[0-9a-f-]+)/$', views.FeatureDeleteView.as_view(), name='feature_delete'),
    # Property year URLs
    re_path(r'^properties/create/$', views.PropertyCreateView.as_view(), name='property_create'),
    re_path(r'^properties/view/(?P<pk>[0-9a-f-]+)/$', views.PropertyDetailView.as_view(), name='property_view'),
    re_path(r'^properties/list/$', views.PropertyListView.as_view(), name='property_list'),
    re_path(r'^properties/update/(?P<pk>[0-9a-f-]+)/$', views.PropertyUpdateView.as_view(), name='property_update'),
    re_path(r'^properties/delete/(?P<pk>[0-9a-f-]+)/$', views.PropertyDeleteView.as_view(), name='property_delete'),
]

tenants/urls.py
from django.urls import re_path
from tenants import views

app_name = 'tenants'

urlpatterns = [
    # DocumentType year URLs
    re_path(r'^document-type/create/$', views.DocumentTypeCreateView.as_view(), name='document_type_create'),
    re_path(r'^document-type/view/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeDetailView.as_view(), name='document_type_view'),
    re_path(r'^document-type/list/$', views.DocumentTypeListView.as_view(), name='document_type_list'),
    re_path(r'^document-type/update/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeUpdateView.as_view(), name='document_type_update'),
    re_path(r'^document-type/delete/(?P<pk>[0-9a-f-]+)/$', views.DocumentTypeDeleteView.as_view(), name='document_type_delete'),
    # Tenant year URLs
    re_path(r'^tenant/create/$', views.TenantCreateView.as_view(), name='tenant_create'),
    re_path(r'^tenant/view/(?P<pk>[0-9a-f-]+)/$', views.TenantDetailView.as_view(), name='tenant_view'),
    re_path(r'^tenant/list/$', views.TenantListView.as_view(), name='tenant_list'),
    re_path(r'^tenant/update/(?P<pk>[0-9a-f-]+)/$', views.TenantUpdateView.as_view(), name='tenant_update'),
    re_path(r'^tenant/delete/(?P<pk>[0-9a-f-]+)/$', views.TenantDeleteView.as_view(), name='tenant_delete'),

    # Tenant year URLs
    re_path(r'^assign-tenant-unit/create/$', views.TenantUnitAssignCreateView.as_view(), name='tenant_unit_assign_create'),
    re_path(r'^assign-tenant-unit/list/$', views.TenantUnitAssignListView.as_view(), name='tenant_unit_assign_list'),
    re_path(r'^assign-tenant-unit/update/(?P<pk>[0-9a-f-]+)/$', views.TenantUnitAssignUpdateView.as_view(), name='tenant_unit_assign_update'),
    re_path(r'^assign-tenant-unit/delete/(?P<pk>[0-9a-f-]+)/$', views.TenantUnitAssignDeleteView.as_view(), name='tenant_unit_assign_delete'),
]

properties/models.py
from decimal import Decimal

from django.core.validators import MinValueValidator
from django.db import models
from django.utils.translation import gettext_lazy as _

from core.models import BaseModel
from tenants.models import TenantUnitAssign


class Feature(BaseModel):
    name = models.CharField(max_length=256)

    class Meta:
        verbose_name = _('Feature')
        verbose_name_plural = _('Features')

    def __str__(self):
        return self.name


class Property(BaseModel):
    name = models.CharField(max_length=256)
    address = models.TextField(null=True, blank=True)
    location = models.CharField(max_length=256)
    features = models.ManyToManyField(Feature, limit_choices_to={'is_deleted': False})

    class Meta:
        verbose_name = _('Property')
        verbose_name_plural = _('Properties')

    def __str__(self):
        return self.name

    def features_names(self):
        return ", ".join([i.name for i in self.features.all()])


class Unit(models.Model):
    UNIT_CHOICES = [
        ('1BHK', '1BHK'),
        ('2BHK', '2BHK'),
        ('3BHK', '3BHK'),
        ('4BHK', '4BHK'),
    ]

    name = models.CharField(max_length=255)
    unit_type = models.CharField("Unit Types", max_length=10, choices=UNIT_CHOICES, default='1BHK')  # TODO: Add dynamic choices
    property = models.ForeignKey(Property, on_delete=models.CASCADE, limit_choices_to={'is_deleted': False})
    rent = models.DecimalField(default=0, decimal_places=2,  max_digits=15, validators=[MinValueValidator(Decimal('0.00'))])
    cost = models.DecimalField(default=0, decimal_places=2,  max_digits=15, validators=[MinValueValidator(Decimal('0.00'))])

    def get_assigned_tenant(self):
        return TenantUnitAssign.objects.filter(is_active=True, unit=self).first()

    def __str__(self):
        return f"{self.name} - {self.get_unit_type_display()}"

templates/includes/dashboard.html
{% load i18n %}
{% load static %}
{% block content %}

<div class="row">
    <div class="col-lg-12">

        <!--end card-->
        <div class="row">

            <div class="col-12 col-lg-6 col-xl">
                <div class="card">
                    <div class="card-body">
                        <div class="row align-items-center">
                            <div class="col text-center">
                                <span class="h4">{{properties.count}}</span>
                                <h6 class="text-uppercase text-muted mt-2 m-0">Properties</h6>
                            </div>
                            <!--end col-->
                        </div> <!-- end row -->
                    </div>
                    <!--end card-body-->
                </div>
                <!--end card-body-->
            </div>
            <!--end col-->
            <div class="col-12 col-lg-6 col-xl">
                <div class="card">
                    <div class="card-body">
                        <div class="row align-items-center">
                            <div class="col text-center">
                                <span class="h4">{{units.count}}</span>
                                <h6 class="text-uppercase text-muted mt-2 m-0">Units</h6>
                            </div>
                            <!--end col-->
                        </div> <!-- end row -->
                    </div>
                    <!--end card-body-->
                </div>
                <!--end card-body-->
            </div>
            <!--end col-->
            <div class="col-12 col-lg-6 col-xl">
                <div class="card">
                    <div class="card-body">
                        <div class="row align-items-center">
                            <div class="col text-center">
                                <span class="h4">{{assigned_units.count}}</span>
                                <h6 class="text-uppercase text-muted mt-2 m-0">Assigned Tenant</h6>
                            </div>
                            <!--end col-->
                        </div> <!-- end row -->
                    </div>
                    <!--end card-body-->
                </div>
                <!--end card-->
            </div>
            <!--end col-->
            <div class="col-12 col-lg-6 col-xl">
                <div class="card">
                    <div class="card-body">
                        <div class="row align-items-center">
                            <div class="col text-center">
                                <span class="h4">{{tenants.count}}</span>
                                <h6 class="text-uppercase text-muted mt-2 m-0">Tenant</h6>
                            </div>
                            <!--end col-->
                        </div> <!-- end row -->
                    </div>
                    <!--end card-body-->
                </div>
                <!--end card-->
            </div>
            <!--end col-->
        </div>
        <!--end row-->
    </div><!-- end col-->


</div>
<!--end row-->

<div class="row">
    <div class="col-lg-6">
        <div class="card">
            <div class="card-header">
                <div class="row align-items-center">
                    <div class="col">
                        <h4 class="card-title">Properties</h4>
                    </div>
                    <!--end col-->
                </div>
                <!--end row-->
            </div>
            <!--end card-header-->
            <div class="card-body">
                <div class="table-responsive">
                    {% if properties %}
                    <table class="table mb-0">
                        <thead class="thead-light">
                            <tr>
                                <th>Name</th>
                                <th>Address</th>
                                <th>Location</th>
                                <th>Features</th>
                                <th>Units</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for instance in properties|slice:":20" %}
                            <tr>
                                <td>{{instance.name}}</td>
                                <td>{{instance.address}}</td>
                                <td>{{instance.location}}</td>
                                <td>{{instance.features_names}}</td>
                                <td>{{instance.unit_set.all.count}}</td>

                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                    {% include 'includes/pagination.html' %}
                    {% else %}
                    {% include 'includes/not_found.html' %}
                    {% endif %}
                    <!--end table-->
                </div>
                <!--end /div-->
            </div>
            <!--end card-body-->
        </div>
        <!--end card-->
    </div>

</div>
<!--end row-->

{% endblock %}

templates/includes/footer.html
{% now 'Y' %}, Created and maintained under
<a class="text-primary" href="#" target="_blank">Shibil</a>. All right reserved.</span>

templates/includes/form.html
<div class="row text-left {{name}}">
    {% for field in form %}
    <div class="col-md-6">
        <div class="form-group">
            <label for="{{ field.id_for_label }}">
                {{ field.label }}
                {% if field.field.required %}
                <small class="star text-danger">*</small>
                {% endif %}
            </label>
            {{ field }}
            {% if field.errors %}
            <label class="error">{{ field.errors.as_text }}</label>
            {% endif %}
            {% if field.help_text %}
            <small class="text-info">{{ field.help_text }}</small>
            {% endif %}
        </div>
    </div>
    {% endfor %}
</div>

templates/includes/menu.html
{% if user.is_superuser %}
<ul class="metismenu left-sidenav-menu">
    <li class="menu-label mt-0">Properties</li>

    <li>
        <a href="{% url 'dashboard'%}"><i data-feather="home" class="align-self-center menu-icon"></i><span>Dashboard</span></a>
    </li>

    <li class="nav-item d-flex justify-content-between {% if active_menu == 'feature' %}active{% endif %}">
        <a class="nav-link" href="{% url 'properties:feature_list' %}"><i data-feather="calendar" class="align-self-center menu-icon"></i>Features</a>
        <a class="nav-link" href="{% url 'properties:feature_create' %}"><i class="ti-plus"></i></a>

    </li>

    <li class="nav-item d-flex justify-content-between {% if active_menu == 'property' %}active{% endif %}">
        <a class="nav-link" href="{% url 'properties:property_list' %}"><i data-feather="dollar-sign" class="align-self-center menu-icon"></i>Property</a>
        <a class="nav-link" href="{% url 'properties:property_create' %}"><i class="ti-plus"></i></a>

    </li>

    <li class="nav-item d-flex justify-content-between {% if active_menu == 'tenant_unit_assign' %}active{% endif %}">
        <a class="nav-link" href="{% url 'tenants:tenant_unit_assign_list' %}"><i data-feather="dollar-sign" class="align-self-center menu-icon"></i>Assigned Tenant</a>
        <a class="nav-link" href="{% url 'tenants:tenant_unit_assign_create' %}"><i class="ti-plus"></i></a>

    </li>


    <li class="menu-label mt-0">Tenants</li>



    <li class="nav-item d-flex justify-content-between {% if active_menu == 'document_type' %}active{% endif %}">
        <a class="nav-link" href="{% url 'tenants:document_type_list' %}"><i data-feather="calendar" class="align-self-center menu-icon"></i>Document Type</a>
        <a class="nav-link" href="{% url 'tenants:document_type_create' %}"><i class="ti-plus"></i></a>

    </li>

    <li class="nav-item d-flex justify-content-between {% if active_menu == 'tenant' %}active{% endif %}">
        <a class="nav-link" href="{% url 'tenants:tenant_list' %}"><i data-feather="dollar-sign" class="align-self-center menu-icon"></i>Tenants</a>
        <a class="nav-link" href="{% url 'tenants:tenant_create' %}"><i class="ti-plus"></i></a>

    </li>







    <hr class="hr-dashed hr-menu">
    <li class="nav-item">
        <a class=" btn btn-sm btn-soft-warning text-secondary" href="javascript:void(0)" onclick="document.getElementById('logout-form').submit()" ><i class="fas fa-accounts mr-2"></i>Logout</a>
    </li>

</ul>
{% endif %}

templates/includes/not_found.html
<div class="card text-center">
    <div class="card-header">
        <h4 class="card-title">Oops!</h4>
    </div>
    <!--end card-header-->
    <div class="card-body">
        <p class="card-text text-muted ">Nothing found.</p>
        <a href="{% url 'dashboard' %}" class="btn btn-primary btn-sm">Back to home</a>
    </div>
    <!--end card-body-->
</div>

templates/includes/pagination.html
{% load core_template_tags %}
{% if page_obj.has_other_pages %}

<nav>
    <div class="row mt-2">
        <div class="col-lg-6">
            <ul class="pagination mb-0">
                {% if page_obj.has_previous %}
                <li class="page-item">
                    <a class="page-link" href="?{% url_replace page='1' %}">
                        <i class="fa fa-angle-double-left" aria-hidden="true"></i>
                    </a>
                </li>
                <li class="page-item">
                    <a class="page-link" href="?{% url_replace page=page_obj.previous_page_number %}" tabindex="-1">
                        <!-- <i class="fa fa-angle-left" aria-hidden="true"></i> -->
                        previous
                    </a>
                </li>
                {% endif %}
                {% for num in page_obj.paginator.page_range|iterator %}
                {% if page_obj.number == num %}
                <li class="page-item active">
                    <a class="page-link" href="javascript:;">{{ num }}<span class="sr-only">(current)</span></a>
                </li>
                {% elif page_obj.paginator.num_pages > 3 and num == page_obj.number|add:'-3' %}
                <!-- <li class="page-item">
                    <a class="page-link" href="?{% url_replace page=page_obj.number|add:'-3' %}" tabindex="-1">
                        <i class="fa fa-angle-left" aria-hidden="true"></i>
                    </a>
                </li> -->
                {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
                <li class="page-item">
                    <a class="page-link" href="?{% url_replace page=num %}">{{ num }}<span class="sr-only">(current)</span></a>
                </li>
                {% elif page_obj.paginator.num_pages > 3 and num == page_obj.number|add:'3' %}
                    <!-- <li class="page-item">
                        <a class="page-link" href="?{% url_replace page=page_obj.number|add:'3' %}">
                            <i class="fa fa-angle-right" aria-hidden="true"></i>
                        </a>
                    </li> -->
                {% endif %}
                {% endfor %}

                {% if page_obj.has_next %}
                <li class="page-item">
                    <a class="page-link" href="?{% url_replace page=page_obj.next_page_number %}">
                        <!-- <i class="fa fa-angle-right" aria-hidden="true"></i> -->
                        next
                    </a>
                </li>
                <li class="page-item">
                    <a class="page-link" href="?{% url_replace page=page_obj.paginator.num_pages  %}">
                        <i class="fa fa-angle-double-right" aria-hidden="true"></i>
                    </a>
                </li>
                {% endif %}
            </ul>
        </div>
        <div class="col-lg-6">
            <span class="current text-right d-block">
                Total Results {{ page_obj.paginator.count }} Showing Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
            </span>
        </div>
    </div>
</nav>
{% endif %}